/* Copyright (C) 2015 Graham Sanderson, All Rights Reserved */
#pragma once

#include "lua/lua.hpp"

#define LuaError(...) (ALERT(at_error, __VA_ARGS__), g_bLuaInitialized = FALSE, LuaQuit(), g_L = NULL)
#define LuaWarning(...) (ALERT(at_warning, __VA_ARGS__))

struct gsLuaRun_s
{
	BOOL	LRUN_CHLR_PLAYER_SPAWN = TRUE,
			LRUN_CHLR_PLAYER_THINK = TRUE;
};

extern lua_State *g_L;
extern BOOL g_bLuaInitialized;
extern struct gsLuaRun_s g_gsLuaRun;

void LuaInit(void);
void LuaQuit(void);
void LuaReload(void);
BOOL LuaCheckNull(void const *vpToCheck);
void LuaCall(char *szFuncName);
void LuaCall(char *szFuncName, int iArgs);
void LuaSetTable(char *szIndex, float fValue);
void LuaSetTable(int iIndex, float fValue);
void LuaSetTable(char *szIndex, vec3_t vValue);
void LuaRunScript(char *szFileName);
BOOL LuaGet(char *szName, int iType, BOOL bGetField, BOOL bWarn);
void LuaParseScripts(void);

